%define name			gcc%{package_suffix}
%define version			3.0.4
%define release			2mdk
%define gcc_target_platform	%{_target_platform}

# Package holding Java tools (gij, jv-convert, etc.)
%define GCJ_TOOLS		gcj%{package_suffix}-tools

# Actually where libgcj.jar should go
%define gcc_datadir		%{_datadir}/gcc-%{version}

# This patch is a quick backport of Nathan Sidwell's patch to fix PR
# c++/3145, the infamous "virtual inheritance" bug. This affected
# especially KDE2 (eg. artsd).
%define PR3145			1

%define multiple_gcc		1
%if %{multiple_gcc}
# (gb) set a lower priority so that a previous gcc-2.96 is still used, if installed
%define alternative_priority	5
%define package_suffix		3.0
%define program_suffix		-%{version}
%else
%define alternative_priority	10
%define package_suffix		%{nil}
%define program_suffix		%{nil}
%endif
%define _alternativesdir	/etc/alternatives

%define RELEASE			1
%if %{RELEASE}
%define source_package		gcc-%{version}
%define source_dir		gcc-%{version}
%else
%define snapshot		20020215
%define source_package		gcc-%{version}-%{snapshot}
%define source_dir		gcc-%{version}-%{snapshot}
%endif

%define color_gcc_version	1.3.2
%define build_pdf_doc		0
%define build_testsuite		0
%define build_fortran		1
%define build_objc		1
%define build_java		1
%define build_debug		0

# libgcj-2.96 is required for libgcjgc.so.1*
%define standalone_libjava	0
%ifarch ia64 ppc
# libgcj-2.96 does not work on those architectures
%define standalone_libjava	1
%endif
%if !%{multiple_gcc}
%define standalone_libjava	1
%endif

# Allow --with[out] <feature> at rpm command line build
%{?_without_PDF: %{expand: %%define build_pdf_doc 0}}
%{?_without_DEBUG: %{expand: %%define build_debug 0}}
%{?_with_PDF: %{expand: %%define build_pdf_doc 1}}
%{?_with_DEBUG: %{expand: %%define build_debug 1}}

%{expand:%%define mdk_version %(A=$(awk '{print $4}' /etc/mandrake-release); if [ -n "$A" ];then echo $A;else echo Cooker;fi)}

Summary:	GNU Compiler Collection
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		Development/C

# Main source:	(CVS)
URL:		http://gcc.gnu.org/
Source0:	%{source_package}.tar.bz2

# ColorGCC:	http://home.i1.net/~jamoyers/software/colorgcc/
Source4:	colorgcc-%{color_gcc_version}.tar.bz2
Patch402:	gcc-3.0-colorgcc-mdkconf.patch.bz2

# Red Hat patches
Patch1:		gcc3-SHF_MERGE.patch.bz2
Patch2:		gcc3-java-libs.patch.bz2
Patch3:		gcc3-c++-weak-address.patch.bz2
Patch4:		gcc3-boehm-gc-libs.patch.bz2
Patch5:		gcc3-boehm-gc-dyn_load.patch.bz2
Patch6:		gcc3-ia64-vararg.patch.bz2
Patch7:		gcc3-c++-template-throw.patch.bz2
Patch8:		gcc3-2.96-RH-tests.patch.bz2
Patch9: 	gcc3-bogus-inline.patch.bz2
Patch10:	gcc3-c++-frepo-env.patch.bz2
Patch11:	gcc3-invalid-stabs.patch.bz2
Patch12:	gcc3-reg-stack-clobber.patch.bz2
Patch15:	gcc3-recog-addressof.patch.bz2
Patch16:	gcc3-libf2c-LFS.patch.bz2

# Merge patch from gcc 3.1 for a working --program-suffix
Patch600:	gcc3-program-transform.patch.bz2

# Build with local boehm-gc includes for Objective C
Patch601:	gcc3-objc_gc.patch.bz2

# Pass datadir to $AM_MAKEFLAGS as well for libjava
Patch602:	gcc3-libjava-datadir.patch.bz2

# Improve Athlon instruction scheduling
Patch603:	gcc3-athlon-tune.patch.bz2

# Better inlining heuristics for the Tree Inliner (C++)
# Adapted for 3.0.3 from Kurt Garloff's v3 patch available here:
# <http://www.garloff.de/kurt/freesoft/gcc/>
Patch604:	gcc3-c++-inline-heuristics.patch.bz2

# Give functions declared inline an advantage over normal functions
# even for the -O3 case to fix the -O3 performance.
Patch605:	gcc3-prefer-inline-O3.patch.bz2

# Fix NaT related problems on IA-64 (Andrew MacLeod)
# <https://external-lists.valinux.com/archives/linux-ia64/2001-November/002495.html>
Patch606:	gcc3-ia64-NaT.patch.bz2

# Fix C++ flat initializers.
Patch607:	gcc3-c++-flat-initializers.patch.bz2

# Temporarily disable default activativation of register renaming at
# -O3 since it looks bogus, at least on ix86 (though it is useless on
# that architecture).
Patch608:	gcc3-no-regrename.patch.bz2

# Add loop-10.c testcase as shown in GNATS PR optimization/5076,
# initially brought up as MDK #4221
Patch609:	gcc3-loop10-testcase.patch.bz2

# toplev.c (rest_of_compilation): Don't perform NOOP_MOVES
# jump_optimization prior to register renaming. However, tidy the CFG
# by deleting unreachable code.
Patch610:	gcc3-no-noop_moves-optimization.patch.bz2

# Fix EH failures with -fomit-frame-pointer and -Ox/x>=1
# (GNATS PR c++/2447, PR c++/5246
Patch611:	gcc3-c++-eh-ofp.patch.bz2

# Avoid renaming of stack registers (Jan Hubicka)
Patch612:	gcc3-i386-no-stackregs-regrename.patch.bz2

BuildRoot:	%{_tmppath}/gcc-%{version}-root
Conflicts:	gcc < 0.60mdk
Requires:	binutils >= 2.11.90.0.8-6mdk
BuildRequires:	binutils >= 2.11.90.0.8-6mdk
BuildRequires:	zlib-devel
Requires:	%{name}-cpp = %{version}-%{release}
Requires:	libgcc3.0 = %{version}
Prereq:		/sbin/install-info
Prereq:		/usr/sbin/update-alternatives
BuildRequires:	gettext, bison, perl, texinfo, sh-utils
BuildRequires:	autoconf
%ifarch ia64
Requires:	glibc-devel >= 2.2.4
BuildRequires:	glibc-devel >= 2.2.4
%else
Requires:	glibc-devel
%endif
%if %{build_pdf_doc}
BuildRequires:	tetex, tetex-dvips
%endif
%if %{build_testsuite}
BuildRequires:	dejagnu
%endif
%if %{multiple_gcc}
Provides:	gcc = %{version}-%{release}
%endif

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.
This package is required for all other GCC compilers, namely C++,
Fortran 77, Objective C and Java.
%if %{multiple_gcc}
If you have multiple versions of GCC installed on your system, it is
preferred to type "gcc-$(gcc3-version)" (without double quotes) in
order to use the GNU C compiler.
%endif

%package -n libgcc3.0
Summary:	GNU C library
Group:		System/Libraries

%description -n libgcc3.0
The libgcc3.0 package contains GCC shared libraries for gcc 3.0

####################################################################
# C++ Compiler

%package c++
Summary:	C++ support for gcc
Group:		Development/C++
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-cpp = %{version}-%{release}, glibc-devel, make
Requires:	libstdc++3.0 = %{version}
Requires:	libstdc++3.0-devel = %{version}
Prereq:		/usr/sbin/update-alternatives
%if %{multiple_gcc}
Provides:	gcc-c++ = %{version}-%{release}
%endif

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.
%if %{multiple_gcc}
If you have multiple versions of GCC installed on your system, it is
preferred to type "g++-$(gcc3-version)" (without double quotes) in
order to use the GNU C++ compiler.
%endif

####################################################################
# C++ Libraries

%package -n libstdc++3.0
Summary:	GNU C++ library
Group:		System/Libraries
Provides:	libstdc++ = %{version}-%{release}

%description -n libstdc++3.0
The libstdc++ package contains a snapshot of the GCC Standard C++
Library v3, an ongoing project to implement the ISO/IEC 14882:1998
Standard C++ library.

%package -n libstdc++3.0-devel
Summary:	Header files and libraries for C++ development
Group:		Development/C++
Requires:	libstdc++3.0 = %{version}
Provides:	libstdc++-devel = %{version}-%{release}

%description -n libstdc++3.0-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development.

####################################################################
# Objective C Compiler

%if %{build_objc}
%package objc
Summary:	Objective C support for gcc
Group:		Development/Other
Requires:	%{name} = %{version}-%{release}, glibc-devel, make
Requires:	libobjc >= 2.96-0.59mdk
%if %{multiple_gcc}
Provides:	gcc-objc = %{version}-%{release}
%endif

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is an object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
Objective C object library.
%endif

####################################################################
# Objective C Libraries

%if %{build_objc}
%package -n libobjc3.0
Summary:	Objective C runtime libraries
Group:		System/Libraries
Provides:	libobjc = %{version}-%{release}
%if %{multiple_gcc}
Conflicts:	gcc-objc < 3.0
%endif

%description -n libobjc3.0
Runtime libraries for the GNU Objective C Compiler.
%endif

####################################################################
# Fortran 77 Compiler

%if %{build_fortran}
%package g77
Summary:	Fortran 77 support for gcc
Group:		Development/Other
Requires:	%{name} = %{version}-%{release}, glibc-devel, make
%if %{multiple_gcc}
Provides:	gcc-g77 = %{version}-%{release}
%endif

%description g77
This package adds support for compiling Fortran 77 programs with the GNU
compiler.
%if %{multiple_gcc}
If you have multiple versions of GCC installed on your system, it is
preferred to type "g77-$(gcc3-version)" (without double quotes) in
order to use the GNU Fortran 77 compiler.
%endif
%endif

####################################################################
# Java Compiler

%if %{build_java}
%package java
Summary:	Java support for gcc
Group:		Development/Java
Requires:	%{name} = %{version}-%{release}
Requires:	libgcj3.0 >= %{version}
Requires:	libgcj3.0-devel >= %{version}
Prereq:		/usr/sbin/update-alternatives
%if %{multiple_gcc}
Provides:	gcc-java = %{version}-%{release}
%endif

%description java
This package adds experimental support for compiling Java(tm) programs
and bytecode into native code. To use this you will also need the
libgcj package.
%endif

####################################################################
# Java Runtime Tools

%if %{build_java}
%package -n %{GCJ_TOOLS}
Summary:	Java related tools from gcc %{version}
Group:		Development/Java
Provides:	gcj-tools = %{version}-%{release}
Requires:	libgcj3.0 >= %{version}
Requires:	libgcj3.0-devel >= %{version}
%endif

%if %{build_java}
%description -n %{GCJ_TOOLS}
This package includes Java related tools built from gcc %{version}:

   * gij: a Java ByteCode Interpreter
   * gcjh: generating C++ header files corresponding to ``.class'' files
   * jcf-dump: printing out useful information from a ``.class'' file
   * jv-scan: printing some useful information from a ``.java'' file
%if %{multiple_gcc}
If you have multiple versions of GCC installed on your system, the
above-mentioned tools are called as follows: "<gcj_tool>-$(gcc3-version)"
(without double quotes).
%endif
%endif

####################################################################
# Java Libraries

%if %{build_java}
%package -n libgcj3.0
Summary:	GNU Java runtime libraries
Group:		System/Libraries
Requires:	zip >= 2.1
%if !%{standalone_libjava}
Requires:	libgcj >= 2.96-4mdk
%endif
Obsoletes:	gcc-libgcj
Provides:	gcc-libgcj = %{version}-%{release}

%description -n libgcj3.0
Runtime libraries for the GNU Java Compiler. The libgcj includes parts
of the Java Class Libraries, plus glue to connect the libraries to the
compiler and the underlying OS.
%endif

%if %{build_java}
%package -n libgcj3.0-devel
Summary:	Header files and libraries for Java development
Group:		Development/Java
Requires:	zip >= 2.1
Requires:	zlib-devel
Requires:	libgcj3.0 = %{version}

%description -n libgcj3.0-devel
Development headers and libraries for the GNU Java Compiler. The
libgcj includes parts of the Java Class Libraries, plus glue to
connect the libraries to the compiler and the underlying OS.
%endif

####################################################################
# Preprocessor

%package cpp
Summary:	The C Preprocessor
Group:		Development/C
Prereq:		/sbin/install-info
Prereq:		/usr/sbin/update-alternatives
%if %{multiple_gcc}
Provides:	gcc-cpp = %{version}-%{release}
%endif

%description cpp
The C preprocessor is a 'macro processor' which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define 'macros,' which are abbreviations for longer
constructs.

The C preprocessor provides four separate facilities that you can use as
you see fit:

* Inclusion of header files. These are files of declarations that can be
  substituted into your program.
* Macro expansion. You can define 'macros,' which are abbreviations for 
  arbitrary fragments of C code, and then the C preprocessor will replace
  the macros with their definitions throughout the program.
* Conditional compilation. Using special preprocessing directives,
  you can include or exclude parts of the program according to various
  conditions.
* Line control. If you use a program to combine or rearrange source files
  into an intermediate file which is then compiled, you can use line
  control to inform the compiler about where each source line originated.

You should install this package if you are a programmer who is searching for
such a macro processor.
%if %{multiple_gcc}
If you have multiple versions of GCC installed on your system, you
will have to type "cpp -V%{version}" or "cpp-%{version}" (without double quotes)
in order to use the GNU C Preprocessor version %{version}.
%endif

####################################################################
# ColorGCC

%package colorgcc
Summary:	Gcc output colorizer
Group:		Development/Other
Provides:	gcc-colorgcc = %{version}-%{release}
Prereq:		%{name}, %{name}-c++
PreReq:		/usr/sbin/update-alternatives
Requires:	perl >= 5.600

%description colorgcc
GCC output colorizer.

####################################################################
# Documentation

%package doc
Summary:	GCC documentation
Group:		Development/Other
Provides:	gcc-doc = %{version}-%{release}
%if %{multiple_gcc}
Conflicts:	gcc-doc < 3.0
%endif

%description doc
GCC is a compiler suite aimed at integrating all the optimizations and
features necessary for a high-performance and stable development
environment.
%if %{build_pdf_doc}
This package contains the compiler printable documentation in PDF, as
well as the INFO pages.
%endif

%prep
%setup -q -n %{source_dir} -a 4

# Red Hat patches
%patch1 -p1 -b .shf_merge
%patch2 -p0 -b .java-libs
%patch3 -p0 -b .c++-weak-address
%patch4 -p0 -b .boehm-gc-libs
%patch5 -p0 -b .boehm-gc-dyn_load
%patch6 -p0 -b .ia64-vararg
%patch7 -p0 -b .c++-template-throw
%patch8 -p0 -b .2.96-RH-tests
%patch9 -p0 -b .bogus-inline
%patch10 -p0 -b .c++-frepo-env
%patch11 -p0 -b .invalid-stabs
%patch12 -p0 -b .reg-stack-clobber
%patch15 -p0 -b .recog-addressof
%patch16 -p1 -b .libf2c-LFS

%patch600 -p1 -b .transform
%patch601 -p1 -b .objc-gc
%patch602 -p1 -b .libjava-datadir
%patch603 -p1 -b .athlon-tune
%patch604 -p1 -b .c++-inline-heuristics
%patch605 -p1 -b .prefer-inline-O3
%ifarch ia64
%patch606 -p1 -b .ia64-NaT
%endif
%patch607 -p1 -b .c++-flat-initializers
%patch608 -p1 -b .no-regrename
%patch609 -p1 -b .loop10-testcase
#%patch610 -p1 -b .no-noop_moves
%patch611 -p1 -b .c++-eh-ofp
%patch612 -p1 -b .i386-no-stackregs-regrename
(cd gcc; autoconf)

%if %{PR3145}
patch -p0 -b -z .pr3145 < contrib/PR3145.patch
%endif

# Mandrakezification for bug reports
perl -pi -e "s/#define GCCBUGURL.*$/#define GCCBUGURL \"<URL:https:\/\/qa.mandrakesoft.com\/>\"/" gcc/system.h
perl -pi -e "s/([0-9]*(\.[0-9]*){1,3}).*(\";)$/\1 \(Mandrake Linux %{mdk_version} %{version}-%{release}\)\3/" gcc/version.c gcc/f/version.c

# ColorGCC patch
(cd colorgcc-%{color_gcc_version};
%patch402 -p2 -b .mdkconf
perl -pi -e 's|GCC_VERSION|%{version}|' colorgcc*
)

%build
# Force a seperate object dir
rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

# Make bootstrap-lean
CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch ia64
# Add -mb-step automatically -- this will go away when production
# hardware is available.
OPT_FLAGS="$OPT_FLAGS -mb-step"
%endif
%if %{build_debug}
OPT_FLAGS=`echo "$OPT_FLAGS -g" | sed -e "s/-fomit-frame-pointer//g"`
%endif
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-fomit-frame-pointer//g'`
LANGUAGES="c,c++"
%if %{build_fortran}
LANGUAGES="$LANGUAGES,f77"
%endif
%if %{build_objc}
LANGUAGES="$LANGUAGES,objc"
%endif
%if %{build_java}
LANGUAGES="$LANGUAGES,java"
%endif
PROGRAM_SUFFIX=""
%if %{multiple_gcc}
PROGRAM_SUFFIX="--program-suffix=%{program_suffix}"
%endif
#LIBSTDCXX_V3_FLAGS="--enable-long-long --enable-cstdio=libio --enable-clocale=gnu"
LIBSTDCXX_V3_FLAGS="--enable-long-long --enable-cstdio=stdio --enable-clocale=generic"
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} --datadir=%{gcc_datadir} \
	--enable-shared --enable-threads=posix --disable-checking $LIBSTDCXX_V3_FLAGS \
	--enable-languages="$LANGUAGES" $PROGRAM_SUFFIX --enable-objc-gc \
	--host=%{gcc_target_platform} --with-system-zlib
touch ../gcc/c-gperf.h
%make bootstrap-lean #BOOT_CFLAGS="$OPT_FLAGS"

# Build libg2c.a with PIC enabled and name the result 'libg2c-pic.a'
%if %{build_fortran}
(cd %{gcc_target_platform};
rm -rf libf2c-pic
cp -a libf2c libf2c-pic
%make -C libf2c-pic clean
%make -C libf2c-pic LIBG2C=libg2c-pic.a CFLAGS="$OPT_FLAGS -fPIC -DPIC"
)
%endif

%if %{build_testsuite}
# Run the tests
# export TCL_LIBRARY=/usr/lib/tcl8.3
# export DEJAGNULIBS=/usr/share/dejagnu
%make -k check || true
%endif

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto
cd ..

# Copy various doc files here and there
mkdir -p rpm.doc/g77
mkdir -p rpm.doc/objc
mkdir -p rpm.doc/libstdc++
mkdir -p rpm.doc/libjava
mkdir -p rpm.doc/libobjc
mkdir -p rpm.doc/boehm-gc
mkdir -p rpm.doc/fastjar

(cd libstdc++-v3; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/libstdc++/$i.libstdc++
done)
%if %{build_fortran}
(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
%endif
%if %{build_objc}
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/libobjc/$i.libobjc
done)
%endif
%if %{build_java}
(cd boehm-gc; for i in ChangeLog*; do
        cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
        cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog LICENSE README; do
	cp -p $i ../rpm.doc/libjava/$i.libffi
done)
(cd libjava; for i in README THANKS COPYING ChangeLog; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)
(cd libjava; cp -p LIBGCJ_LICENSE ../rpm.doc/libjava/LICENSE.libjava)
%endif

# [ghibo] - build printable documentation
%if %{build_pdf_doc}
(cd gcc/doc; for file in gcc.texi cpp.texi ../f/g77.texi cppinternals.texi; do
	texi2dvi -p -t @afourpaper -t @finalout $file
done)
%endif

%install
rm -rf $RPM_BUILD_ROOT

# Create some directories, just to make sure (e.g. ColorGCC)
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_mandir}
mkdir -p $RPM_BUILD_ROOT%{_infodir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}

# ColorGCC stuff
(cd colorgcc-%{color_gcc_version};
  install -m 755 colorgcc $RPM_BUILD_ROOT%{_bindir}/colorgcc%{program_suffix}
  install -m 644 colorgccrc $RPM_BUILD_ROOT%{_sysconfdir}
  for i in COPYING CREDITS ChangeLog; do
    [ ! -f ../$i.colorgcc ] && mv -f $i ../$i.colorgcc
  done
)

(cd obj-%{gcc_target_platform};

  # A "fix" from Debian
  [ -f %{gcc_target_platform}/boehm-gc/.libs/libgcjgc.lai ] \
  || sed -e 's/^installed=no/installed=yes/' \
       %{gcc_target_platform}/boehm-gc/libgcjgc.la \
       > %{gcc_target_platform}/boehm-gc/.libs/libgcjgc.lai

  MAKE=make
  %ifarch ppc
  # FIXME: oddly, datadir macro won't be overriden hereunder...
  MAKE="$MAKE -e"
  %endif

  $MAKE prefix=$RPM_BUILD_ROOT%{_prefix} \
        mandir=$RPM_BUILD_ROOT%{_mandir} \
        infodir=$RPM_BUILD_ROOT%{_infodir} \
        datadir=$RPM_BUILD_ROOT%{gcc_datadir} \
        install

  # Install libg2c-pic.a
  (cd %{gcc_target_platform};
    $MAKE -C libf2c-pic LIBG2C=libg2c-pic.a \
          prefix=$RPM_BUILD_ROOT%{_prefix} \
          mandir=$RPM_BUILD_ROOT%{_mandir} \
          infodir=$RPM_BUILD_ROOT%{_infodir} \
          datadir=$RPM_BUILD_ROOT%{gcc_datadir} \
          install)
)

FULLVER=`$RPM_BUILD_ROOT%{_bindir}/%{gcc_target_platform}-gcc%{program_suffix} --version | cut -d' ' -f1`
FULLPATH=$(dirname $RPM_BUILD_ROOT%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/cc1)

if [ "%{gcc_target_platform}" != "%{_target_platform}" ]; then
   mv -f $RPM_BUILD_ROOT%{_bindir}/%{gcc_target_platform}-gcc $RPM_BUILD_ROOT%{_bindir}/%{_target_platform}-gcc
fi

file $RPM_BUILD_ROOT/%{_bindir}/* | grep ELF | cut -d':' -f1 | xargs strip || :
strip $FULLPATH/{cc1,cc1plus,cpp0,tradcpp0}
%if %{build_fortran}
strip $FULLPATH/f771
%endif
%if %{build_java}
strip $FULLPATH/{jc1,jvgenmain}
%endif

# Create /usr/bin/gcc3-version that contains the full version of gcc
cat >$RPM_BUILD_ROOT%{_bindir}/gcc3-version <<EOF
#!/bin/sh
echo "$FULLVER"
EOF
chmod +x $RPM_BUILD_ROOT%{_bindir}/gcc3-version

# Fix program names
# (gb) For each primary program in every package, I want it to be
# named <program>-<version>
(cd $RPM_BUILD_ROOT%{_bindir}; for file in cpp gcc g++ gcj g77; do
	file_version="${file}-%{version}"
	if [ -x "$file" -a "(" ! -x "$file_version" -o -L "$file_version" ")" ]; then
		cp -f $file $file_version
		rm -f $file
		ln -s $file_version $file
	fi
done)

# Fix some links
ln -sf gcc $RPM_BUILD_ROOT%{_bindir}/cc
rm -f $RPM_BUILD_ROOT%{_infodir}/dir

# Dispatch libraries to the right directories
DispatchLibs() {
	libname=$1 libversion=$2
	rm -f $libname.so $libname.a
%if %{multiple_gcc}
	# If we have multiple versions of GCC, leave libraries in $FULLPATH
	ln -s ../../../$libname.so.$libversion $libname.so
	rm -f ../../../$libname.so
	cp -f ../../../$libname.a $libname.a
	rm -f ../../../$libname.a
	%ifarch ppc
	[ -d nof ] || mkdir nof
	(cd nof;
	ln -s ../../../../nof/$libname.so.$libversion $libname.so
	rm -f ../../../../nof/$libname.so
	[ -r "../../../../nof/$libname.a" ] && {
	cp -f ../../../../nof/$libname.a $libname.a
	rm -f ../../../../nof/$libname.a
	})
	%endif
%else
	ln -sf ../../../$libname.so $libname.so
	ln -sf ../../../$libname.a $libname.a
	%ifarch ppc
	[ -d nof ] || mkdir nof
	(cd nof;
	ln -sf ../../../../nof/$libname.so $libname.so
	ln -sf ../../../../nof/$libname.a $libname.a
	)
	%endif
%endif
}
(cd $FULLPATH;
	DispatchLibs libstdc++	3.0.4
	mv ../../../libsupc++.a libsupc++.a
	%ifarch ppc
	[ -d nof ] || mkdir nof
	mv ../../../nof/libsupc++.a nof/libsupc++.a
	%endif
	%if %{build_java}
	DispatchLibs libgcj	2.0.0
	DispatchLibs libgcjgc	1.0.1
	%endif
	%if %{build_objc}
	mv libobjc* ../../../
	DispatchLibs libobjc	1.0.0
	DispatchLibs libobjc_gc	1.0.0
	%endif
)

# Move Java headers to compiler-specific dir
%if %{build_java}
mv $RPM_BUILD_ROOT%{_includedir}/j*.h $FULLPATH/include/
mv $RPM_BUILD_ROOT%{_includedir}/{gcj,gnu,java} $FULLPATH/include/
%endif

# Move libgcj.spec to compiler-specific directories
%if %{build_java}
mv $RPM_BUILD_ROOT%{_libdir}/libgcj.spec $FULLPATH/libgcj.spec
%endif

# Move <cxxabi.h> to compiler-specific directories
mv $RPM_BUILD_ROOT%{_includedir}/g++-v3/cxxabi.h $FULLPATH/include/

# Fix links to binaries
(cd $RPM_BUILD_ROOT%{_bindir};
	ln -sf colorgcc%{program_suffix} colorg++%{program_suffix}
	for file in cpp gcc g++; do [ -e $file ] && mv $file "$file"-%{version}; done
	%if %{build_java}
	for file in gcjh jcf-dump jv-scan; do [ -e $file -a -n "%{program_suffix}" ] && mv $file "$file"-%{version}; done
	%endif
)

# Create an empty file with perms 0755
FakeAlternatives() {
  for file in ${1+"$@"}; do
    touch $file
    chmod 0755 $file
  done
}

# Alternatives provide /lib/cpp and %{_bindir}/cpp
(cd $RPM_BUILD_ROOT%{_bindir}; FakeAlternatives cpp)
(mkdir -p $RPM_BUILD_ROOT/lib; cd $RPM_BUILD_ROOT/lib; ln -sf %{_bindir}/cpp cpp)

# Alternatives provide /usr/bin/{g77,f77}
(cd $RPM_BUILD_ROOT%{_bindir}; FakeAlternatives g77 f77)

# Alternatives provide /usr/bin/c++
(cd $RPM_BUILD_ROOT%{_bindir}; FakeAlternatives c++)

# Move libgcc_s.so* to /lib
(cd $RPM_BUILD_ROOT/lib;
	chmod +x $RPM_BUILD_ROOT%{_libdir}/libgcc_s.so.1
	mv -f $RPM_BUILD_ROOT%{_libdir}/libgcc_s.so.1 libgcc_s-%{version}.so.1
	ln -sf libgcc_s-%{version}.so.1 libgcc_s.so.1
	ln -sf libgcc_s.so.1 libgcc_s.so
%ifarch ppc
	chmod +x $RPM_BUILD_ROOT%{_libdir}/libgcc_s_nof.so.1
	mv -f $RPM_BUILD_ROOT%{_libdir}/libgcc_s_nof.so.1 libgcc_s_nof-%{version}.so.1
	ln -sf libgcc_s_nof-%{version}.so.1 libgcc_s_nof.so.1
	ln -sf libgcc_s_nof.so.1 libgcc_s_nof.so
%endif
)

# FIXME: cpp, gcov manpages names
(cd $RPM_BUILD_ROOT%{_mandir}/man1;
  mv cpp.1 cpp%{program_suffix}.1
  mv gcov.1 gcov%{program_suffix}.1
)
	
%if %{build_debug}
# Don't strip in debug mode
export DONT_STRIP=1
%endif

%clean
#rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_bindir}/gcc gcc %{_bindir}/gcc-%{version} %{alternative_priority}
[ -e %{_bindir}/gcc ] || update-alternatives --auto gcc

%postun
[ "$1" = "0" ] || exit 0
update-alternatives --remove gcc %{_bindir}/gcc-%{version}

%post colorgcc
update-alternatives --install %{_bindir}/gcc gcc %{_bindir}/colorgcc%{program_suffix} %(expr %{alternative_priority} + 10)
update-alternatives --install %{_bindir}/g++ g++ %{_bindir}/colorg++%{program_suffix} %(expr %{alternative_priority} + 10) \
                      --slave %{_bindir}/c++ c++ %{_bindir}/colorg++%{program_suffix}

%postun colorgcc
[ $1 = 0 ] || exit 0
update-alternatives --remove gcc %{_bindir}/colorgcc%{program_suffix}
update-alternatives --remove g++ %{_bindir}/colorg++%{program_suffix}

%post c++
update-alternatives --install %{_bindir}/g++ g++ %{_bindir}/g++-%{version} %{alternative_priority} --slave %{_bindir}/c++ c++ %{_bindir}/g++-%{version}
[ -e %{_bindir}/g++ ] || update-alternatives --auto g++

%postun c++
[ $1 = 0 ] || exit 0
update-alternatives --remove g++ %{_bindir}/g++-%{version}

%post -n libstdc++3.0 -p /sbin/ldconfig
%postun -n libstdc++3.0 -p /sbin/ldconfig

%post -n libgcc3.0 -p /sbin/ldconfig
%postun -n libgcc3.0 -p /sbin/ldconfig

%post cpp
update-alternatives --install %{_bindir}/cpp cpp %{_bindir}/cpp-%{version} %{alternative_priority} --slave /lib/cpp lib_cpp %{_bindir}/cpp-%{version}
[ -e %{_bindir}/cpp ] || update-alternatives --auto cpp

%postun cpp
[ $1 = 0 ] || exit 0
update-alternatives --remove cpp %{_bindir}/cpp-%{version}

%if %{build_fortran}
%post g77
update-alternatives --install %{_bindir}/g77 g77 %{_bindir}/g77-%{version} %{alternative_priority} --slave %{_bindir}/f77 f77 %{_bindir}/g77-%{version}
[ -e %{_bindir}/g77 ] || update-alternatives --auto g77

%postun g77
[ $1 = 0 ] || exit 0
update-alternatives --remove g77 %{_bindir}/g77-%{version}
%endif

%if %{build_java}
%post java
update-alternatives --install %{_bindir}/gcj gcj %{_bindir}/gcj-%{version} %{alternative_priority}
[ -e %{_bindir}/gcj ] || update-alternatives --auto gcj

%postun java
[ $1 = 0 ] || exit 0
update-alternatives --remove gcj %{_bindir}/gcj-%{version}
%endif

%if %{build_java}
%post -n libgcj3.0 -p /sbin/ldconfig
%postun -n libgcj3.0 -p /sbin/ldconfig
%endif

%if %{build_objc}
%post -n libobjc3.0 -p /sbin/ldconfig
%postun -n libobjc3.0 -p /sbin/ldconfig
%endif

%post doc
%_install_info gcc.info
%_install_info cpp.info
%_install_info g77.info

%preun doc
if [ "$1" = "0" ];then /sbin/install-info %{_infodir}/gcc.info.bz2 --dir=%{_infodir}/dir --remove;fi;
%_remove_install_info cpp.info
%_remove_install_info g77.info

%files
%defattr(-,root,root)
#
%doc gcc/README* gcc/*ChangeLog*
%{_mandir}/man1/gcc%{program_suffix}.1*
%{_mandir}/man1/gcov%{program_suffix}.1*
#
%{_bindir}/gcc3-version
%{_bindir}/gcc-%{version}
%{_bindir}/%{_target_platform}-gcc%{program_suffix}
%{_bindir}/protoize%{program_suffix}
%{_bindir}/unprotoize%{program_suffix}
%{_bindir}/gcov%{program_suffix}
%{?!%{multiple_gcc}: %{_bindir}/cc}
#
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/cc1
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/collect2
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/crt*.o
%ifarch ppc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/ecrt*.o
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/scrt*.o
%endif
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/SYSCALLS.c.X
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/specs
%ifarch ppc
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/crt*.o
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/ecrt*.o
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/scrt*.o
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libgcc.a
%endif
#
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/float.h
%if %{build_fortran}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/g2c.h
%endif
%ifarch ppc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/ppc-asm.h
%endif
%ifarch ia64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/ia64intrin.h
%endif
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/iso646.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/limits.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/proto.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/stdarg.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/stdbool.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/stddef.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/stdio.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/syslimits.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/varargs.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/README

%files -n libgcc3.0
%defattr(-,root,root)
/lib/libgcc_s-%{version}.so.1
/lib/libgcc_s.so
/lib/libgcc_s.so.1
%ifarch ppc
/lib/libgcc_s_nof-%{version}.so.1
/lib/libgcc_s_nof.so
/lib/libgcc_s_nof.so.1
%endif

%files cpp
%defattr(-,root,root)
#
%{_mandir}/man1/cpp%{program_suffix}.1*
#
/lib/cpp
%ghost %{_bindir}/cpp
%{_bindir}/cpp-%{version}
#
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/cpp0
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/tradcpp0

%files c++
%defattr(-,root,root)
#
%doc gcc/cp/ChangeLog*
%{_mandir}/man1/g++%{program_suffix}.1*
#
%ghost %{_bindir}/c++
%{_bindir}/g++-%{version}
%{_bindir}/c++%{program_suffix}
%{_bindir}/c++filt%{program_suffix}
%{_bindir}/%{_target_platform}-g++%{program_suffix}
%{_bindir}/%{_target_platform}-c++%{program_suffix}
#
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/cc1plus

%files -n libstdc++3.0
%defattr(-,root,root)
%{_libdir}/libstdc++.so.3
%{_libdir}/libstdc++.so.3.0.4
%ifarch ppc
%dir %{_libdir}/nof
%{_libdir}/nof/libstdc++.so.3
%{_libdir}/nof/libstdc++.so.3.0.4
%endif

%files -n libstdc++3.0-devel
%defattr(-,root,root)
#
%doc rpm.doc/libstdc++/*
#
%dir %{_includedir}/g++-v3
%{_includedir}/g++-v3/*
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/cxxabi.h
#
%{?!%{multiple_gcc}: %{_libdir}/libstdc++.so}
%{?!%{multiple_gcc}: %{_libdir}/libstdc++.a}
%{?!%{multiple_gcc}: %{_libdir}/libsupc++.a}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libstdc++.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libstdc++.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libsupc++.a
%ifarch ppc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libstdc++.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libstdc++.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libsupc++.a
%endif

%if %{build_objc}
%files objc
%defattr(-,root,root)
#
%doc rpm.doc/objc/*
#
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/cc1obj
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libobjc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libobjc.so*
%ifarch ppc
#%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libobjc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libobjc.so*
%endif
#
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/objc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/objc/*.h
%endif

%if %{build_objc}
%files -n libobjc3.0
%defattr(-,root,root)
#
%doc rpm.doc/libobjc/*
%doc libobjc/THREADS* libobjc/ChangeLog
#
%{_libdir}/libobjc.so.1
%{_libdir}/libobjc.so.1.0.0
%{_libdir}/libobjc_gc.so.1
%{_libdir}/libobjc_gc.so.1.0.0
%endif

%if %{build_fortran}
%files g77
%defattr(-,root,root)
#
%doc gcc/f/README rpm.doc/g77/*
%{_mandir}/man1/g77%{program_suffix}.1*
#
%ghost %{_bindir}/g77
%ghost %{_bindir}/f77
%{_bindir}/g77-%{version}
#
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/f771
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libg2c.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libg2c-pic.a
%ifarch ppc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libg2c.a
#%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libg2c-pic.a
%endif
#
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/g2c.h
%endif

%if %{build_java}
%files java
%defattr(-,root,root)
%doc gcc/java/ChangeLog*
%{_bindir}/gcj-%{version}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/jc1
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/jvgenmain
%endif

%if %{build_java}
%files -n %{GCJ_TOOLS}
%defattr(-,root,root)
%{_bindir}/gij%{program_suffix}
%{_bindir}/gcjh%{program_suffix}
%{_bindir}/jcf-dump%{program_suffix}
%{_bindir}/jv-scan%{program_suffix}
%endif

%if %{build_java}
%files -n libgcj3.0
%defattr(-,root,root)
#
%{_libdir}/libgcj.so.2
%{_libdir}/libgcj.so.2.0.0
%{?%{standalone_libjava}: %{_libdir}/libgcjgc.so.1}
%{?%{standalone_libjava}: %{_libdir}/libgcjgc.so.1.0.1}
#
%dir %{gcc_datadir}
%{gcc_datadir}/libgcj.jar
%endif

%if %{build_java}
%files -n libgcj3.0-devel
%defattr(-,root,root)
#
%doc rpm.doc/boehm-gc/*
%doc rpm.doc/fastjar/*
%doc rpm.doc/libjava/*
#
%{_bindir}/jv-convert%{program_suffix}
#
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/jni.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/jvmpi.h
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gcj
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gcj/*.h
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gnu
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gnu/*
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/java
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/java/*
#
%{?!%{multiple_gcc}: %{_libdir}/libgcj.a}
%{?!%{multiple_gcc}: %{_libdir}/libgcj.so}
%{?!%{multiple_gcc}: %{_libdir}/libgcjgc.a}
%{?!%{multiple_gcc}: %{_libdir}/libgcjgc.so}
#
%ifarch ppc
%{?!%{multiple_gcc}: %{_libdir}/nof/libgcj.a}
%{?!%{multiple_gcc}: %{_libdir}/nof/libgcj.so}
%{?!%{multiple_gcc}: %{_libdir}/nof/libgcjgc.a}
%{?!%{multiple_gcc}: %{_libdir}/nof/libgcjgc.so}
%endif
#
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcj.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcjgc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcjgc.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcj.spec
#
%ifarch ppc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libgcj.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libgcjgc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/nof/libgcjgc.so
%endif
%endif

%files colorgcc
%defattr (-,root,root)
%doc COPYING.colorgcc CREDITS.colorgcc ChangeLog.colorgcc
%config(noreplace) %{_sysconfdir}/colorgccrc
%{_bindir}/colorgcc%{program_suffix}
%{_bindir}/colorg++%{program_suffix}

%files doc
%defattr(-,root,root)
%if %{build_pdf_doc}
%doc gcc/doc/cppinternals.pdf
%doc gcc/doc/gcc.pdf
%doc gcc/doc/cpp.pdf
%{?%{build_fortran}: %doc gcc/doc/g77.pdf}
%endif
%{_infodir}/cppinternals.info*
%{_infodir}/cpp.info*
%{_infodir}/gcc.info*
# (gb) don't use the %{?%{build_fortran}: ...} syntax, rpm has
# troubles with that...
%if %{build_fortran}
%{_infodir}/g77.info*
%endif

%changelog
* Wed Feb 27 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.4-2mdk
- Patch612: Avoid renaming of stack registers (Jan Hubicka)

* Thu Feb 21 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.4-1mdk
- Update to 3.0.4 Release
- Add %%dir %{gcc_datadir}/
- Remove Patch611 since it is already integrated upstream
- Patch611: Fix EH failures with -fomit-frame-pointer and -Ox/x>=1
  (Jason Merrill, temptative patch from gcc-patches mailing-list)

* Wed Feb 20 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.4-0.4mdk
- Move <cxxabi.h> into gcc3-specific includedir
- Re-add g77 info pages that disappeared through rpm mysteries
- Add Requires: zlib-devel for libgcj3.0-devel
- Add +x bits to /lib/libgcc_s-3.0.4.so.1
- Add alternative c++ for %{_bindir}/g++-%{version}
- Fix %%preun doc wrt. to removal of g77.info
- Patch611: decl.c (start_method): Fix error in 2002-01-10 change

* Sat Feb 16 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.4-0.3mdk
- Update to Prerelease snapshot 2002/02/15.
- Add Debian "fix" for libgcjgc.
- Remove Patch610 since it was too aggresive. Apply Patch608 instead.

* Sat Feb  9 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.4-0.2mdk
- Add --with-system-zlib to the configure flags
- Add Provides: gcj-tools = %%{version}-%%{release} for gcj3.0-tools
- Patch610: toplev.c (rest_of_compilation): Don't perform NOOP_MOVES
  jump_optimization prior to register renaming. However, tidy the CFG
  by deleting unreachable code. (Fix PR c/4257, PR c/5049, PR c/5250)

* Wed Feb  6 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.4-0.1mdk
- Add Conflicts: gcc-objc < 3.0 for libobjc3.0.
- Disable Patch608. aka. Re-enable default activation of register
  renaming at -O3 as I have to see a real world application that
  suffers from that. MPlayer doesn't count since it had bogus asm
  contraints anyway.
- Update to 3.0.4 prerelease snapshot 2002/02/06, which brings:
  - Fix for GNATS PR optimization/5076, PR optimization/2847, MDK #4221
  - Fix Alpha ICE in summarize_insn()
  - Fix several C++ related bugs

* Fri Jan 25 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.3-2mdk
- Add various Provides: clauses, fully-qualify version-release tag
- Removed duplicate directories from %%files (Stefan)
- Patch607: Fix C++ flat initializers. (Richard Sandiford)
- Patch608: Temporarily disable default activativation of register
  renaming at -O3 since it looks bogus, at least on ix86.

* Wed Dec 26 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.3-1mdk
- Update to 3.0.3 Release
- Update gcc version string Mandrakezification pattern
- Patch606: Fix NaT related problems on IA-64 (Andrew MacLeod)

* Wed Dec 19 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.3-0.1mdk
- Update to 3.0.3 Prerelease snapshot 2001/12/17
- Sanitize specfile and get rid of SPARC bits
- Now [Build]Requires: binutils >= 2.11.90.0.8-6mdk
- Add a new subpackage for Java related tools generated from gcc tarball
- Fix PPC build and add <ppc-asm.h> header
- 8 new or improved patches:
  - Temporarily (?) enable patch for PR c++/3145 which is a quick
    backport for the infamous "virtual inheritance" bug. This affected
    especially KDE2 (e.g. artsd).
  - Patch1: config/alpha/elf.h (DO_SELECT_SECTION): Fix selection of
    small data sections based on size. (Fix Alpha build)
  - Patch16: Regenerate so that it could be applied to gcc-3.0.3
  - Patch600: Improve handling of --program-suffix configure option
    (Andreas Franck, gcc-3.1 CVS)
  - Move libgcj.jar to /usr/share/gcc-%%{version}/libgcj.jar. Also
    make sure to pass datadir to AM_MAKEFLAGS as well (Patch602)
  - Patch603: Improve Athlon instruction scheduling.
    (Jan Hubicka, SuSE release 3.0.X-30)
  - Patch604: Change heuristic for inlining of functions in C++:
    Rather than allowing one single function to exhaust the limit,
    allow only half way. Afterwards don't cut abruptly, but get more
    and more restrictive until a minimum size. This gives better
    runtime and compiletime results than the old heuristic.
    (Kurt Garloff, SuSE release 3.0.X-34)
  - Patch605: Give functions declared inline an advantage over normal
    functions even for the -O3 case to fix the -O3 performance.
    (Kurt Garloff, <http://www.garloff.de/kurt/freesoft/gcc/>)

* Thu Oct 25 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.2-1mdk
- Release 3.0.2
- Update %%description with the preferred use of "<program>-$(gcc3-version)"
  when calling a gcc3 compiler
- Actually [Build]Requires: binutils >= 2.11.90.0.8-4.1mdk on IA-64
- Remove patch to remove -fvtable-thunks (already gone in sources)
- Don't remove -lgcjgc, -lpthread from libgcj.spec
- Build libg2c.a with -fPIC -DPIC and name the result 'libg2c-pic.a'.
  Use this library when building dynamically loadable objects, or with
  packages which are linked against g2c (e.g. R-base, lapack). Packages needing
  '-lg2c-pic' must have a BuildRequires: gcc3.0-g77 >= 3.0.2-1mdk
- Merge with Red Hat 3.0.1 rel4 (2 new/updated patches):
  - handle large files in Fortran (#53328)
  - allow Java programs to be statically linked (#53605)

* Mon Oct 15 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.2-0.1mdk
- Update to 3.0.2 prerelease
- [Build]Requires: binutils >= 2.11.90.0.8-5.1mdk on IA-64
- Add --with[out] <feature> at rpm command line build, where <feature> is:
  - PDF: build PDF docs (off by default)
  - DEBUG: build with debugging info (off by default)
- Ghost alternatives are now touched as 0755
- Fix gcc3.0-doc to conflict with any gcc-doc < 3.0
- Rework Patch8 to remove gcc.c-torture/execute/20010403-1.c (merged upstream)
- Merge with Red Hat 3.0.1 rel3 (9 new patches):
  - fix boehm-gc for prelink
  - fix IA-64 varargs handling in presence of additional anonymous arguments
    (#50757)
  - properly handle throw() exception specifiers in template decls (#51824)
  - add 36 testcases from gcc-2.96-RH
  - fix ICE on very questionable C++ code from JDK (#39858, #52960)
  - fix -frepo (Nathan Sidwell, #52877)
  - avoid generating bogus .stabs (#49214)
  - issue a clear error message about invalid ia32 floating point
    asm constraints (#27137)
  - fix ADDRESSOF recognition (#29686)

* Tue Aug 21 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.1-1mdk
- Release 3.0.1
- Patch402: recreate so that paths for colorgcc are definitely correct
- Add [Build]Requires: glibc-devel >= 2.2.4 for ia64
- Merge with RedHat rel6:
  - don't warn about if (&foo) if foo is weak (H.J.Lu, #50855)

* Fri Aug 17 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.1-0.3mdk
- Update to second release candidate 2001/08/16
- Always add alternatives for gcc3 and now conflict with gcc-2.96 < 0.60mdk

* Fri Aug  3 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.1-0.2mdk
- Prerelease snapshot 2001/08/02
- Fix build on ia64
- Add fastjar documentation
- Remove Patch3 (merged upstream)
- Remove Obsoletes: gcc-doc. Users currently have to remove gcc-doc (2.96)
  and install gcc3.0-doc instead if they wish

* Thu Aug  2 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.1-0.1mdk
- Prerelease snapshot 2001/07/24
- Fix alternatives for /usr/bin/{cpp,g77,f77}
- Now build Fortran 77, Objective C and Java on IA-64
- Don't ship %{_bindir}/jar
- Don't ship %{_libdir}/libobjc.so.1 (provided by libobjc)
- Don't ship PDF docs
- Move gcc300-version to gcc3-version
- Move %{_libdir}/libgcc_s.so.1 to /lib/libgcc_s-%%{version}.so.1
  and fix related links
- Shortened ChangeLog to match only gcc3 entries
- Merge with Red Hat rel5

* Mon Jul  2 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-3mdk
- gcc3.0-doc obsoletes gcc-doc (Titi)
- don't omit frame pointer when compiling libraries with exception handling
  (actually, remove -fomit-frame-pointer for all the build)

* Mon Jul  2 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-2mdk
- applied patch for colorgcc
- revived PDF docs
- enabled Fortran 77 for ia64
- s|Linux-Mandrake|Mandrake Linux|;

* Mon Jun 18 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 3.0-1mdk
- final release

* Tue Jun 12 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-0.7mdk
- prerelease snapshot 2001/06/11
- configure: regenerated patch800
- specfile: cleaned up BuildRequires (texinfo, sh-utils)
- specfile: it is now possible to disable more languages
- IA-64: disable Fortran 77, Objective C, Java
- IA-64: now requires binutils >= 2.11.90.0.15

* Tue May 29 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-0.6mdk
- prerelease snapshot 2001/05/28
- cleaned up specfile (lib versions, Java exclusions)

* Sat May 26 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-0.5mdk
- prerelease snapshot 2001/05/25
- enable Boehm's garbage collector for Objective C [patch802: missing include dir]
- converted patch801 to a perl script so that some hunks of the patch
don't get rejected among different snapshots

* Fri May 25 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-0.4mdk
- CVS snapshot from 2001/05/21
- configure: removed --enable-haifa
- optflags: removed -fvtable-thunks, now unsupported [patch801]
- optflags: removed -fomit-frame-pointer, was generating incorrect code
- packages: clarified %descriptions
- packages: added "Provides" for libs

* Thu May 17 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-0.3mdk
- CVS snapshot from 2001/05/11
- libstdc++-v3: --enable-cstdio='generic' (fail if 'libio' for 20010514+)
- libstdc++-v3: --enable-clocale='generic' (fail if 'gnu' for 20010511)
- added libgcj3.0, libgcj3.0-devel, libobjc3.0
- added missing files for Java
- added guards before adding alternatives for gcj, cpp
- renamed libgcc0 to libgcc3.0
- cleaned up specfile

* Fri May 11 2001 Gwenole Beauchesne <gb@kenobi.mandrakesoft.com> 3.0-0.2mdk
- CVS snapshot from 2001/05/11
- added missing files for PPC, mostly
- fixed typos in gcc3.0-doc description

* Thu May 10 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0-0.1mdk
- CVS snapshot from 2001/05/09
- added libgcc0
- added alternatives for cpp, gcj
- programs in %{_bindir} are suffixed with "-3.0", had to fix that in
  configure scripts as well [patch800]

# Local Variables:
# tab-width: 8
# End:
